// src/backend/concrete_simulation_statistics.hh - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#ifndef CONCRETE_SIMULATION_STATISTICS_HH
#define CONCRETE_SIMULATION_STATISTICS_HH 1

#include "config.h"

#include <sgpemv2/simulation_statistics.hh>
#include "concrete_process_statistics.hh"


namespace sgpem
{
	class ConcreteStatistics;
	
	class ConcreteSimulationStatistics : public SimulationStatistics
	{
		public:			
			friend class ConcreteStatistics;
			
			~ConcreteSimulationStatistics();			
			
			float	get_average_inactivity_time() const ;
			float	get_average_turn_around() const ;
			float	get_average_response_time() const ;
			float	get_average_efficiency() const ;
			int		get_terminated_processes() const ;
			int		get_terminated_threads() const ;
			float	get_average_throughput() const ;
			
		protected:
			ConcreteSimulationStatistics(const std::vector<ConcreteProcessStatistics> proc_stats, const int& instant);
			
			float	_average_inactivity_time ;
			float	_average_turn_around ;
			float	_average_response_time ;
			float	_average_efficiency ;
			int		_terminated_processes ;
			int		_terminated_threads ;
			float	_average_throughput ;
	};
}  

   
#endif


   
