// src/backend/concrete_statistics.hh - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#ifndef CONCRETE_STATISTICS_HH
#define CONCRETE_STATISTICS_HH 1

#include "config.h"

#include <sgpemv2/statistics.hh>
#include "concrete_process_statistics.hh"
#include "concrete_simulation_statistics.hh"

#include <glibmm/ustring.h>
#include <vector>

namespace sgpem
{
	class ConcreteStatistics;

	class ConcreteStatistics : public Statistics
	{
		public:
			ConcreteStatistics();
			
			void										calculateStatisticsAt(const int& instant);
			
			const SimulationStatistics*			 		get_simulation_statistics() const;
			std::vector<const ProcessStatistics*>		get_process_statistics() const;			
 		
		private:
			
			ConcreteSimulationStatistics*				_sim_stats;
			std::vector<ConcreteProcessStatistics>		_proc_stats;
	};
}

#endif


